---
AWSTemplateFormatVersion: '2010-09-09'
Description: Creates account specific IAM resources

Resources:
###########################################
#                                         #
# Users with SSH access                   #
#                                         #
###########################################
{% for user in ssh_users %}
  {{ user.name | capitalize | replace('-', '') }}:
    Type: "AWS::IAM::User"
    Properties:
      UserName: {{ user.name }}
{% if (user.groups | count | ternary(True, False)) %}
      Groups:
{% for group in user.groups %}
        - {{ group }}
{% endfor %}
{% endif %}
  SSHPublicKey{{ user.name | capitalize | replace('-', '') }}:
    Type: "Custom::IAMSSHPublicKey"
    Properties:
      SSHPublicKeyBody: "{{ user.ssh_pub_key }}"
      UserName: !Ref {{ user.name | capitalize | replace('-', '') }}
      ServiceToken:
        Fn::ImportValue: !Sub "lambda-cfnsecretsprovider-LambdaARN"
{% endfor %}
###########################################
#                                         #
# Automation user with CodeCommit access  #
#                                         #
###########################################
  CodeCommit:
    Type: "AWS::IAM::Group"
    Properties:
      GroupName: CodeCommit
      ManagedPolicyArns:
        - arn:aws:iam::aws:policy/AWSCodeCommitReadOnly
        - arn:aws:iam::aws:policy/IAMUserSSHKeys
        - arn:aws:iam::aws:policy/IAMReadOnlyAccess

  Automation:
    Type: "AWS::IAM::User"
    Properties:
      UserName: automation
      Groups:
        - !Ref CodeCommit

  AutomationSSHKeyPair:
    Type: "Custom::RSAKey"
    Properties:
      Name: "/automation/ssh/keypair"
      Description: "Keypair used by Automation to check out CodeCommit"
      KeySize: 2048
      ServiceToken:
        Fn::ImportValue: !Sub "lambda-cfnsecretsprovider-LambdaARN"
  
  SSHPublicKeyAutomation:
    Type: "Custom::IAMSSHPublicKey"
    Properties:
      SSHPublicKeyBody: !GetAtt AutomationSSHKeyPair.PublicKey
      UserName: !Ref Automation
      ServiceToken:
        Fn::ImportValue: !Sub "lambda-cfnsecretsprovider-LambdaARN"

Outputs:
  SSHPublicKeyAutomation:
    Value: !GetAtt SSHPublicKeyAutomation.SSHPublicKeyId
    Export:
      Name: !Sub "${AWS::StackName}-SSHPublicKeyAutomationId"
